`timescale 1ns/100ps

module testbench();
  parameter SYSCLK_PERIOD = 100; // 10 MHz

  reg SYSCLK;
  reg NSYSRESET;

  wire ICE_nSRST;
  pullup (weak1) p1 (ICE_nSRST);

  initial
   begin
    SYSCLK = 1'b0;
    NSYSRESET = 1'b0;

    // Release system reset
    #(SYSCLK_PERIOD * 4)
    NSYSRESET = 1'b1;

    #(SYSCLK_PERIOD * 100000);

    $stop;
  end

 // SYSCLK signal
  always @(SYSCLK)
   #(SYSCLK_PERIOD / 2)
   SYSCLK <= !SYSCLK;

 // Instantiate module to test

  TutorialTop TutorialTop_0 (
    .SYSCLK(SYSCLK),
    .NSYSRESET(NSYSRESET),
    .RemapDefault(1'b0),
    .HIGH(),
    .LOW(),
    .FLASH_BYTEN(),
    .FLASH_CSN(),
    .FLASH_OEN(),
    .FLASH_RPN(),
    .FLASH_WEN(),
    .SRAM_ADSC(),
    .SRAM_ADSP(),
    .SRAM_ADV(),
    .SRAM_BYTEN(),
    .SRAM_BYTE_WEN(),
    .SRAM_CLK(),
    .SRAM_CSN(),
    .SRAM_GLOBAL_WEN(),
    .SRAM_OEN(),
    .SRAM_PWRDWN(),
    .MEM_ADDR(),
    .MEM_DATA(),
    .SW(8'b0),
    .LED(),
    .RX0(1'b0), 
    .TX0(),
    .ICE_nTRST(),
    .ICE_TCK(1'b0),
    .ICE_TDI(1'b0),
    .ICE_TMS(1'b1),
    .ICE_VTref(),
    .ICE_TDO(),
    .ICE_RTCK(),
    .ICE_nSRST(ICE_nSRST),
    .ICE_DBGACK(),
    .ICE_DBGRQ()
  );

endmodule
