#include <stdio.h>
#include "Reversi.h"
#include "UserInput.h"
#include "UARTComChannel.h"

const int INITIAL_X	= 2;
const int INITIAL_Y	= 2;
const int MAX_X = 8;
const int MIN_X	= 1;
const int MAX_Y = MAX_X;
const int MIN_Y = MIN_X;

int main()
{
	Reversi	m_reversi;
	UserInput user;
	int xCurrent, yCurrent;
	InputKey key;
	UARTComChannel uart;

#if USE_SEMI_HOSTING_FOR_OUTPUT == 1	
	printf("\nStarting Reversi\n");
#endif
	
	m_reversi.RegisterComChannel((ComChannel *)&uart);
	
	xCurrent = INITIAL_X;
	yCurrent = INITIAL_Y;
	key = DOWN_KEY;
	
	m_reversi.SetSelectedSquare(xCurrent, yCurrent);
	
	while (1)
	{
	    m_reversi.SetSelectedSquare(xCurrent, yCurrent);
	    
	    key = user.GetKeyPress();
	    
	    switch(key)
	    {
	        case UP_KEY:
	            if (yCurrent > MIN_Y)
	            {
	                yCurrent--;
	            }
	            break;
	            
	        case DOWN_KEY:
	            if (yCurrent < MAX_Y)
	            {
	                yCurrent++;
	            }
	            break;
	            
	        case LEFT_KEY:
	            if (xCurrent > MIN_X)
	            {
	                xCurrent--;
	            }
	            break;
	            
	        case RIGHT_KEY:
	            if (xCurrent < MAX_Y)
	            {
	                xCurrent++;
	            }
	            break;
	            
	        case SELECT_KEY:
        		if ( m_reversi.RequestHumanMove(xCurrent, yCurrent) )
        		{
        			m_reversi.RequestComputerMove();
        			m_reversi.GetSelectedSquare(&xCurrent, &yCurrent);	
        		}
	            break;
	    }
	}
}
