
#ifndef REVERSI_HEADER
#define REVERSI_HEADER

//#include "ReversiCfg.h"		// to know if we are running on the host

//#include "UserInput.h"
#include "Game.h"
#include "engine.h"
#include "BoardView.h"
#include "ComChannel.h"


class Reversi {
public:
	Reversi();
	~Reversi();
	
	void RegisterComChannel(ComChannel *comChannel);
	//
	// Use to show the user navigating the board before selecting her next move.
	//
	void SetSelectedSquare(int x, int y);
	void GetSelectedSquare(int *x, int *y);
	
	bool RequestHumanMove(int x, int y);
	void RequestComputerMove();
	bool IsGameOver();
	

#if RUN_GAME_ENGINE_ON_HOST
//	void Play(int x, int y);
#else
	void Play();
#endif

private:
//	void HumanMakeMove(Move humanMove);
	void ComputerMakeMove();
	void DisplayGameOver();

private:
	bool		m_competitiveGame;
	bool		m_gameOver;

//#if RUN_GAME_ENGINE_ON_HOST==0	
//	UserInput	m_humanInput;
//#endif

	Game		m_game;
	Engine		m_engine;
	BoardView	m_boardView;

};

#endif	// REVERSI_HEADER
