#ifndef __SYSREGSDEF
#define __SYSREGSDEF

/*****************************************************************************/
/* System Regs Structure maps to register offsets                            */
/* Structure is instantiated in sysRegs.c and placed by scatter file         */
/*****************************************************************************/

typedef	volatile struct SysRegs_t
{
    uint8_t ledControlReg;         // @0x0
	const uint8_t	pad0_[ 3 ];
    uint8_t userSwitchStatusReg;   // @0x4
	const uint8_t	pad1_[ 3 ];
    uint8_t keypadStatusReg;       // @0x8
	const uint8_t	pad2_[ 3 ];
    uint8_t lcdControlReg;         // @0xc
	const uint8_t	pad3_[ 3 ];
    uint8_t lcdDataReg;            // @0x10
} SysRegs_t;

extern SysRegs_t sysRegs0;

typedef	SysRegs_t* pSysRegs_t;

extern pSysRegs_t pSysRegs0;

void setupSysRegs(void);

/*****************************************************************************/
/* Keypad Status Register                                                    */
/*****************************************************************************/
#define KSR_Left    0x10
#define KSR_Right   0x08
#define KSR_Up      0x04
#define KSR_Down    0x02
#define KSR_Home    0x01

/*****************************************************************************/
/* LCD Control Register                                                      */
/*****************************************************************************/
#define LCR_LCD_TR  0x04
#define LCR_LCD_RS  0x02
#define LCR_LCD_E   0x01

#endif /* __SYSREGSDEF */
